Loading...
Searching...
No Matches
openshot::Color Class Reference

This class represents a color (used on the timeline and clips). More...

`#include <Color.h>`

## Public Member Functions

| Color ()
| Default constructor.
| Color (const char *color_hex)
| Color (openshot::Keyframe Red, openshot::Keyframe Green, openshot::Keyframe Blue, openshot::Keyframe Alpha)
| Constructor which takes 4 existing Keyframe curves.
| Color (QColor)
| Constructor which takes a QColor.
| Color (std::string color_hex)
| Constructor which takes a hex string ("#rrggbb").
| Color (unsigned char Red, unsigned char Green, unsigned char Blue, unsigned char Alpha)
| Constructor which takes R,G,B,A.
std::string | GetColorHex (int64_t frame_number)
| Get the HEX value of a color at a specific frame.
std::vector< int > | GetColorRGBA (int64_t frame_number)
std::string | Json () const
| Generate JSON string of this object.
Json::Value | JsonValue () const
| Generate Json::Value for this object.
void | SetJson (const std::string value)
| Load JSON string into this object.
void | SetJsonValue (const Json::Value root)
| Load Json::Value into this object.

## Static Public Member Functions

static long | GetDistance (long R1, long G1, long B1, long R2, long G2, long B2)
| Get the distance between 2 RGB pairs. (0=identical colors, 10=very close colors, 760=very different colors).

## Public Attributes

openshot::Keyframe | alpha
| Curve representing the alpha value (0 - 255).
openshot::Keyframe | blue
| Curve representing the red value (0 - 255).
openshot::Keyframe | green
| Curve representing the green value (0 - 255).
openshot::Keyframe | red
| Curve representing the red value (0 - 255).

## Detailed Description

This class represents a color (used on the timeline and clips).

Colors are represented by 4 curves, representing red, green, blue, and alpha. The curves can be used to animate colors over time.

Definition at line 27 of file Color.h.

## Constructor & Destructor Documentation

## Color() [1/6]

openshot::Color::Color | ( |  | ) |

inline

Default constructor.

Definition at line 36 of file Color.h.

Referenced by Color(), and Color().

## Color() [2/6]

Color::Color | ( | QColor | qcolor | ) |

explicit

Constructor which takes a QColor.

Definition at line 32 of file Color.cpp.

## Color() [3/6]

Color::Color | ( | std::string | color_hex | ) |

explicit

Constructor which takes a hex string ("#rrggbb").

Definition at line 40 of file Color.cpp.

## Color() [4/6]

Color::Color | ( | const char * | color_hex | ) |

explicit

Definition at line 43 of file Color.cpp.

## Color() [5/6]

Color::Color | ( | unsigned char | Red,
|  | unsigned char | Green,
|  | unsigned char | Blue,
|  | unsigned char | Alpha )

Constructor which takes R,G,B,A.

Definition at line 21 of file Color.cpp.

## Color() [6/6]

Color::Color | ( | openshot::Keyframe | Red,
|  | openshot::Keyframe | Green,
|  | openshot::Keyframe | Blue,
|  | openshot::Keyframe | Alpha )

Constructor which takes 4 existing Keyframe curves.

Definition at line 28 of file Color.cpp.

## Member Function Documentation

## GetColorHex()

std::string Color::GetColorHex | ( | int64_t | frame_number | ) |

Get the HEX value of a color at a specific frame.

Definition at line 47 of file Color.cpp.

## GetColorRGBA()

std::vector< int > Color::GetColorRGBA | ( | int64_t | frame_number | ) |

Definition at line 58 of file Color.cpp.

## GetDistance()

long Color::GetDistance | ( | long | R1,
|  | long | G1,
|  | long | B1,
|  | long | R2,
|  | long | G2,
|  | long | B2 )

static

Get the distance between 2 RGB pairs. (0=identical colors, 10=very close colors, 760=very different colors).

Definition at line 69 of file Color.cpp.

Referenced by openshot::ChromaKey::GetFrame().

## Json()

std::string Color::Json | ( |  | ) | const

Generate JSON string of this object.

Definition at line 79 of file Color.cpp.

## JsonValue()

Json::Value Color::JsonValue | ( |  | ) | const

Generate Json::Value for this object.

Definition at line 86 of file Color.cpp.

Referenced by Json().

## SetJson()

void Color::SetJson | ( | const std::string | value | ) |

Load JSON string into this object.

Definition at line 100 of file Color.cpp.

## SetJsonValue()

void Color::SetJsonValue | ( | const Json::Value | root | ) |

Load Json::Value into this object.

Definition at line 117 of file Color.cpp.

Referenced by SetJson().

## Member Data Documentation

## alpha

openshot::Keyframe openshot::Color::alpha

Curve representing the alpha value (0 - 255).

Definition at line 33 of file Color.h.

Referenced by Color(), Color(), Color(), GetColorHex(), GetColorRGBA(), JsonValue(), and SetJsonValue().

## blue

openshot::Keyframe openshot::Color::blue

Curve representing the red value (0 - 255).

Definition at line 32 of file Color.h.

Referenced by Color(), Color(), Color(), GetColorHex(), GetColorRGBA(), JsonValue(), and SetJsonValue().

## green

openshot::Keyframe openshot::Color::green

Curve representing the green value (0 - 255).

Definition at line 31 of file Color.h.

Referenced by Color(), Color(), Color(), GetColorHex(), GetColorRGBA(), JsonValue(), and SetJsonValue().

## red

openshot::Keyframe openshot::Color::red

Curve representing the red value (0 - 255).

Definition at line 30 of file Color.h.

Referenced by Color(), Color(), Color(), GetColorHex(), GetColorRGBA(), JsonValue(), and SetJsonValue().

The documentation for this class was generated from the following files:

- Color.h
- Color.cpp